# -*- coding: utf-8 -*-

import sys #tmp

class Events:
	def __init__(self):
		self.scheduler = None
		self.script = None
		self.events = []
		self.eventposition = 0

	def setscheduler(self, scheduler):
		self.scheduler = scheduler

	def setscript(self, script):
		self.script = script

		events = []

		try:
			f = open(script)
			lines = f.readlines()
			f.close()

			for l in lines:
				l = l.strip()
				if l == "" or l[0] == "#":
					continue
				fields = l.split(" ")
				time = int(fields[0])
				command = " ".join(fields[1:])
				#print "== command", command, "at time", time, "=="
				events.append((time, command))
		except:
			print "<events: error loading script - discarding all events>"
			self.script = None
			return

		for event in events:
			(time, command) = event
			for i in range(len(self.events)):
				(t, c) = self.events[i]
				if t > time:
					head = self.events[0:i]
					tail = self.events[i:]
					self.events  = head + [(time, command)] + tail
					event = None
					break
			if event:
				self.events.append(event)

	def run(self):
		if self.scheduler and self.eventposition < len(self.events):
			#print "TIME", self.scheduler.time(), self.events[self.eventposition]
			(time, command) = self.events[self.eventposition]
			if self.scheduler.time() > time:
				print "++++++ EVENT", time, ":", command
				scheduler = self.scheduler
				exec(command)
				self.eventposition += 1

events = Events()
